void PlotNhat(const char* fname = "nheff.dat")
{
   ifstream ins(fname);
   int n = 0;
   double xdat[100], dxdat[100], ydat[100], dydat[100], dummy;
   while (ins >> dummy >> xdat[n] >> ydat[n] >> dydat[n]) {
      dxdat[n] = 0.;
      n++;
   }
   auto grp = new TGraphErrors(n,xdat,ydat,dxdat,dydat);
   auto &gr = *grp;
   gr.SetMinimum(0.);
   gr.SetMaximum(7.);
   gr.GetXaxis()->SetTitle("drift length [cm]");
   gr.GetYaxis()->SetTitle("#hat{N}_{eff}");
   gr.GetXaxis()->SetTitleSize(0.06);
   gr.GetXaxis()->SetLabelSize(0.05);
   gr.GetXaxis()->SetTitleOffset(0.75);
   gr.GetYaxis()->SetTitleSize(0.06);
   gr.GetYaxis()->SetLabelSize(0.05);
   gr.GetYaxis()->SetTitleOffset(0.6);
   gr.SetTitle("");
   gr.GetXaxis()->SetRangeUser(0.,61.);
   gr.Draw("apc");
   gPad->SetGridx();
   gPad->SetGridy();
}
