#include "PbarSI.h"
#include "PlotPbarY.C"
#include "TF1.h"
#include "TLine.h"

#include <iostream>

using namespace std;

void PlotPbarYAll()
{ 
  const int kMax = 10;
  int kdat[] = { 1, 5, 10, 20, 50, 100, 200, 400, 800, 999 };
  int color  = 0;
  for (int ik=0; ik<kMax; ik++) {
      int k = kdat[ik];
      auto fp = PlotPbarY(k);
      fp->SetLineColor(++color%5+1);
      //fp->SetMaximum(7.);
#if 0
      stringstream cname;
      cname << "c" << kdat[ik] << ends;
      TCanvas *cp = new TCanvas(cname.str().data(),
		                cname.str().data(),400.,400.);
      cp->cd();
      fp->DrawCopy();
#else
      if (!ik) {
          auto fcp = fp->DrawCopy();
          //--
          // Draw pad boundaries
          //--
          double hwid = 5.36/2;
          double ymax = 1.2*fp->GetMaximum();
          fcp->GetHistogram()->SetMaximum(ymax);
	  cerr << "hwid = " << hwid << " ymax = " << ymax << endl;
          TLine *line = new TLine(-hwid,0.,-hwid,ymax);
          line->SetLineStyle(2);
          line->Draw("same");
          line = new TLine(+hwid,0.,+hwid,ymax);
          line->SetLineStyle(2);
          line->Draw("same");
      } else {
          fp->DrawCopy("same");
      }
#endif
  }
}
