#!/bin/sh
#
#--
# Set run parameters
#--
#--- tan(phi)
#tanf=0.00
#tanf=0.10 # 5.71 deg
#tanf=0.087 # 5 deg
#tanf=0.176 # 10 deg
#tanf=0.20 # 11.3 deg
#tanf=0.262 # 15 deg
#tanf=0.364 # 20 deg
#tanf=0.524 # 30 deg
#--
#--- drift length [mm]
#dlen=5.0 # sigd = 0.0679 for cd = 0.096
#dlen=10.085 # sigd = 0.10 for cd = 0.096
#dlen=24.414 # sigd = 0.15 for cd = 0.096
#dlen=43.403 # sigd = 0.20 for cd = 0.096
#dlen=79.102 # sigd = 0.27 for cd = 0.096
#dlen=173.611 # sigd = 0.40 for cd = 0.096
#dlen=271.267 # sigd = 0.50 for cd = 0.096
#dlen=610.352 # sigd = 0.75 for cd = 0.096
#--
# Loop over xt
#--
#cmd=echo # for test
cmd=eval
for dlen in 5.000 10.085 24.414 43.403 79.102 173.611 271.267 610.352; do
  for tanf in 0.000 0.087 0.176 0.262 0.364 0.524; do
    for xt in 0.0000 0.1550 0.3125 0.4650 0.6250; do
      $cmd "root -l -b -q sg.C\($tanf\,$dlen\,$xt\) >& run.tanf$tanf.dlen$dlen.xt$xt.log &"
    done
  done
  wait
done
#--
# That's it, folks!
#--
exit 0
