#include <iomanip>
//void sg(double tanf = 0.20, double sigd = 0.27, double xtld = 0.0000)
void sg(double tanf = 0.00, double z = 10., double xtld = 0.0000)
{
    //gSystem->Load("libPrf.so.2012.01"); 

    double tanl = 0.00;
#if 1
    double l    = 5.36; // LP1
#  if 1
#    if 1
    double w    = 1.15; // row 16 
#    else
    double w    = 0.50; // row 16 
#    endif
#  else
    double w    = 1.25; // row 12 
#  endif
#  if 0
    double nav  = 30.;
#  else
#    if 0
    double nav  = 27.5;  // <#primary ionizations> [1/cm] for MIP (from HEED for T2K)
#    else
#      if 0
    double nav  = 15.5;  // <#primary ionizations> [1/cm] for MIP (fit to beam test)
    //double nav  = 16.5;  // <#primary ionizations> [1/cm] for MIP (fit to beam test)
           nav *= 1.38;  // 5 GeV electron > MIP
#      else
    double nav  = 27.5;  // <#primary ionizations> [1/cm] for MIP (from HEED for T2K)
           nav *= 1.38;  // 5 GeV electron > MIP
#      endif
#    endif
#  endif
#  if 1
    double sigp = 0.27;  // Asian GEM garfield++ (2016)
#  else
    double sigp = 0.22;  // Asian GEM fit to data
#  endif
    double cd   = 0.096/TMath::Sqrt(10.); // T2K 1T
#else
    double l    = 6.30; // MPTPC
    double w    = 1.27;
    //double nav  = 34.126; // TDR 1T neff=27.326
#  if 0
    double nav  = 29.722; // TDR 1T neff=23.8
    double sigp = 0.261;  // TDR 1T
    double cd   = 0.212/TMath::Sqrt(10.); // TDR 1T
#  else
    double nav  = 27.239; // P5 1T neff=21.81
    double sigp = 0.376;  // P5 1T
    double cd   = 0.170/TMath::Sqrt(10.); // P5 1T
#  endif
#endif
    double sigd = cd*TMath::Sqrt(z);
    //double dy   = 20.0;
    double nsig = 5.;
    double dy   = l + 2*(sigp + sigd)*nsig;
    double nbar = (nav/10.)*TMath::Sqrt(1+tanl*tanl*+tanf*tanf)*dy;
    TPC::Av av(xtld,tanf,sigd,l,dy,sigp,w);
    TPC::PbarSI &pbar = av.GetPbarSI();
    TPC::Gain gain;

    stringstream fname;
    fname << "terms.new"
          << ".tanf" << setw(5) << setprecision(3) << setiosflags(ios::fixed) << tanf
          << ".sigd" << setw(5) << setprecision(3) << setiosflags(ios::fixed) << sigd
          << ".xtld" << setw(6) << setprecision(4) << setiosflags(ios::fixed) << xtld 
          << ".root" << ends;
    auto fp = new TFile(fname.str().data(),"RECREATE");
    auto tp = new TNtupleD("evt","","tf:sgd:xt:ev:n:nok:k:g1:g1g1:g1g2:dx:bt:dt:gt:at");

    //int nev = 10000;
    int nev = 40000;
    for (int iev=0; iev<nev; iev++) {
        int n = gRandom->Poisson(nbar);
        std::vector<int> kv;
	int K   = 0;
        for (int i=0; i<n; i++) {
            int k = pbar.GetRandom(); 
            if (k) {
                kv.push_back(k);
	        K += k;
            }
	}
	if (!K) {
            tp->Fill(tanf,sigd,xtld,iev,n,0,0,-1.,-1.,-1.,-1.,-1.,-1.,-1.,-1.);
            continue;
        }
	double g1   = gain.G1(K);
	double g1g1 = gain.G1G1(K);
	double g1g2 = gain.G1G2(K);
        int nok  = kv.size();
#if 0
	int amax = 2;
#else
	double nsigx = 3.;
#if 0
	int    amax = (sigp+sigd)*nsigx/w + 1;
#else
	int    amax = ((sigp+sigd)*nsigx+tanf*l)/w + 1;
#endif
#endif
	int amin = -amax;
	int bmin = amin;
	int bmax = amax;
	double xav  = 0;
	double sumb = 0;
	double sumd = 0;
	double sumg = 0;
	double suma = 0;
        for (int a=amin; a<=amax; a++) {
            if (!a) continue;
            for (int b=bmin; b<=bmax; b++) {
                if (!b) continue;
		// -----------------
		// B-term (1st line)
		// -----------------
                double bsumab = 0;
                for (int i = 0; i<nok; i++) {
                    int k = kv[i];
                    double val = (av.AvFF(a,b,k)-av.AvFAvF(a,b,k))*k;
                    bsumab += val;
                    //cerr << "k: " << k << " val:" << val << endl;
                }
                bsumab *= (a*b*w*w)*g1g1/(K*K);
		sumb   += bsumab;
		// -----------------
		// D-term (2nd line)
		// -----------------
		double dsumab = 0;
                for (int i = 0; i<nok; i++) {
                    int k = kv[i];
                    double val = (av.AvFAvF(a,b,k)-av.AvF(a,k)*av.AvF(b,k))
			    *(k*g1g1 + k*(k-1)*g1g2);
                    dsumab += val;
                    //cerr << "k: " << k << " val:" << val << endl;
                }
                dsumab *= (a*b*w*w)/(K*K);
		sumd   += dsumab;
		// -----------------
		// G-term (3rd line)
		// -----------------
		double gsumab = 0;
                for (int i = 0; i<nok; i++) {
                    int ki = kv[i];
                    for (int ip = 0; ip<nok; ip++) {
                        int kip = kv[ip];
                        double val = av.AvF(a,ki)*av.AvF(b,kip)
                                    *((i == ip ? ki*g1g1 + ki*(ki-1)*g1g2
                                              : ki*kip*g1g2) - ki*kip*g1*g1);
                        gsumab += val;
                        //cerr << "k: " << k << " val:" << val << endl;
                    }
                }
                gsumab *= (a*b*w*w)/(K*K);
		sumg   += gsumab;
#if 0
		// ---------------------
		// Summary of this (a,b)
		// ---------------------
		cerr << "a:" << a << " b:" << b << " K:" << K 
                     << " g1g1:" << g1g1 << " g1g2:" << g1g2
                     << " bsumab:" << bsumab  << " dsumab:" << dsumab
		     << endl << "      "
                     << " gsumab:" << gsumab  
                     << " sumb:" << sumb << " sumd:" << sumd 
                     << " sumg:" << sumg << endl;
#endif
            }
            // -----------------
            // A-term (4th line)
            // -----------------
            double asuma = 0;
            for (int i = 0; i<nok; i++) {
                int k = kv[i];
                double val = av.AvF(a,k)*k*g1;
                asuma += val;
                //cerr << "k: " << k << " val:" << val << endl;
            }
	    asuma *= (a*w)/K;
            xav   += asuma;
        }
	double delx = xav - xtld;
	suma = TMath::Power(xav-xtld,2);
        cerr << "----------------------------------------------------------"
             << "------------------------------"                             << endl
             << "ev: " << iev  << " N:" << n    << " nok:" << nok
             << " K:"  << K    << " B:" << sumb << " D:"   << sumd
             << " G:"  << sumg << " A:" << suma << " dx:"  << delx           << endl
             << "----------------------------------------------------------" 
             << "------------------------------"                             << endl;
	tp->Fill(tanf,sigd,xtld,iev,n,nok,K,g1,g1g1,g1g2,delx,sumb,sumd,sumg,suma);
    }
    fp->Write();
}
